Index: trunk/kernel/libk/remote_rwlock.h
===================================================================
--- trunk/kernel/libk/remote_rwlock.h	(revision 690)
+++ trunk/kernel/libk/remote_rwlock.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
- * remote_rwlock.h - kernel remote read/write lock definition.
+ * remote_rwlock.h - kernel remote_rwlock definition.
  *
- * Authors   Alain Greiner   (2016,2017,2018,2020)
+ * Authors   Alain Greiner   (2016)
  * 
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,82 +25,72 @@
 #define _REMOTE_RWLOCK_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <remote_busylock.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <xlist.h>
 
-/*******************************************************************************************
- * This structure defines a kernel, global, read/write lock, supporting several simultaneous
- * read accesses, but only one write access to a globally shared object, that can be
- * accessed by threads running in any cluster.
- * Both readers and writers take the associated busylock before accessing or updating
- * the rwlock state, and releases the busylock after rwlock state update.
- * - when a reader try to access the object, it increments the readers "count" when the 
- *   lock is not "taken" by a writer. It registers in the "rd_root" waiting queue, blocks,
- *   and deschedules when the lock is taken.
- * - when a writer try to take the rwlock, it check the "taken" field. If the lock is already
- *   taken, or if the number of readers is non zero, it registers in the "wr_root" waiting
- *   queue, blocks, and deschedules. It set "taken" otherwise.
- * - when a reader completes its access, it decrement the readers "count", unblock 
- *   the first waiting writer if there is no other readers, and unblock all waiting
- *   readers if there no write request.
- * - when a  writer completes its access, it reset the "taken" field, releases the first
- *   waiting writer if queue non empty, or releases all waiting readers if no writer.
- ******************************************************************************************/
-
-
-/*******************************************************************************************
- * This structure defines a remote rwlock.
- ******************************************************************************************/
+/***************************************************************************************
+ * This structure defines a remote rwdlock,that supports several simultaneous read 
+ * accesses, but only one write access. It implements a ticket based allocation policy.
+ * It can be used to synchronize threads running in different clusters, because
+ * all access functions use remote pointers.
+ * - A reader take the lock to atomically increments the registered readers count.
+ *   Then it release the lock and access the protected structure. It atomically 
+ *   decrements the readers count without taking the lock when access is completed.
+ * - A writer take the lock and keep it, but must wait completion of all current read 
+ *   accesses before starting its own access.
+ * When the lock is taken by another thread, the new-comers use a busy waiting policy.
+ *
+ * TODO This could be replaced by a descheduling policy and a threads waiting queue
+ * implemented in the lock itself: each thread releasing the lock (i.e. incrementing
+ * the current field) activates the first waiting thread... 
+ **************************************************************************************/
 
 typedef struct remote_rwlock_s
 {
-    remote_busylock_t   lock;        /*! busylock protecting the rwlock state             */
-	volatile uint32_t   taken;       /*! lock taken by an exclusive writer if non zero    */
-    volatile uint32_t   count;       /*! current number of simultaneous readers threads   */
-    xlist_entry_t       rd_xroot;    /*! root of list of waiting readers                  */
-    xlist_entry_t       wr_xroot;    /*! root of list of waiting writers                  */
-}
+    uint32_t     ticket;                /*! first free ticket index                   */
+    uint32_t     current;               /*! ticket index of current owner             */
+    uint32_t     count;                 /*! current number of reader threads          */
+    xptr_t       owner;                 /*! extended pointer on writer thread         */
+} 
 remote_rwlock_t;
-
 
 /***************************************************************************************
  * This function initializes a remote rwlock.
- * The <type> argument defines the lock usage and is only used for debug.
- * This type is actually stored in the associated busylock descriptor.
  ***************************************************************************************
  * @ lock_xp    : extended pointer on the remote rwlock
- * @ type       : lock usage for debug.
  **************************************************************************************/
-void remote_rwlock_init( xptr_t   lock_xp,
-                         uint32_t type );
+void remote_rwlock_init( xptr_t lock_xp );
 
 /***************************************************************************************
  * This blocking function get access to a remote rwlock for a reader.
+ * It increments the calling thread locks count when the lock has been taken.
  ***************************************************************************************
  * @ lock_xp    : extended pointer on the remote rwlock
  **************************************************************************************/
-void remote_rwlock_rd_acquire( xptr_t lock_xp );
+void remote_rwlock_rd_lock( xptr_t lock_xp );
 
 /***************************************************************************************
  * This function releases a remote rwlock for a reader.
+ * It decrements the calling thread locks count when the lock has been released.
  ***************************************************************************************
  * @ lock_xp    : extended pointer on the remote rwlock
  **************************************************************************************/
-void remote_rwlock_rd_release( xptr_t lock_xp );
+void remote_rwlock_rd_unlock( xptr_t lock_xp );
 
 /***************************************************************************************
  * This blocking function get access to a remote rwlock for a writer.
+ * It increments the calling thread locks count when the lock has been taken.
  ***************************************************************************************
  * @ lock_xp    : extended pointer on the remote rwlock
  **************************************************************************************/
-void remote_rwlock_wr_acquire( xptr_t lock_xp );
+void remote_rwlock_wr_lock( xptr_t lock_xp );
 
 /***************************************************************************************
  * This function releases a remote rwlock for a writer.
+ * It decrements the calling thread locks count when the lock has been released.
  ***************************************************************************************
  * @ lock_xp    : extended pointer on the remote rwlock
  **************************************************************************************/
-void remote_rwlock_wr_release( xptr_t lock_xp );
+void remote_rwlock_wr_unlock( xptr_t lock_xp );
 
 #endif
Index: trunk/kernel/libk/remote_spinlock.c
===================================================================
--- trunk/kernel/libk/remote_spinlock.c	(revision 1)
+++ trunk/kernel/libk/remote_spinlock.c	(revision 1)
@@ -0,0 +1,153 @@
+/*
+ * remote_spinlock.c - kernel remote spinlock implementation.
+ * 
+ * Authors  Mohamed Karaoui (2015)
+ *          Alain   Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_types.h>
+#include <hal_remote.h>
+#include <hal_irqmask.h>
+#include <thread.h>
+#include <cluster.h>
+#include <scheduler.h>
+#include <remote_spinlock.h>
+
+////////////////////////////////////////
+void remote_spinlock_init( xptr_t lock )
+{ 
+    remote_spinlock_t * ptr = (remote_spinlock_t *)GET_PTR( lock );
+    cxy_t               cxy = GET_CXY( lock );
+
+    hal_remote_sw ( XPTR( cxy , &ptr->taken ) , 0 );
+    hal_remote_swd( XPTR( cxy , &ptr->owner ) , XPTR_NULL );
+    xlist_entry_init( XPTR( cxy , &ptr->list ) ); 
+}
+
+///////////////////////////////////////////////
+uint32_t remote_spinlock_trylock( xptr_t lock )
+{ 
+	uint32_t            mode;
+	bool_t              isAtomic = false;
+
+    // get cluster and local pointer on remote_spinlock
+    remote_spinlock_t * lock_ptr = (remote_spinlock_t *)GET_PTR( lock );
+    cxy_t               lock_cxy = GET_CXY( lock );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // disable interrupts
+    hal_disable_irq( &mode );
+
+	if( hal_remote_lw( XPTR( lock_cxy , &lock_ptr->taken ) ) == 0 )
+    {
+		isAtomic = hal_remote_atomic_cas( XPTR( lock_cxy , &lock_ptr->taken ) , 0 , 1 );
+    }
+
+	if( isAtomic == false )    // failure 
+	{
+		hal_restore_irq( mode );
+		return 1;
+	}
+    else                      // success : register lock in thread
+    {
+	    thread_ptr->remote_locks++;
+
+        hal_remote_swd( XPTR( lock_cxy , &lock_ptr->owner ) ,
+                    (uint64_t)XPTR( thread_cxy , thread_ptr) );
+
+        xlist_add_first( XPTR( thread_cxy , &thread_ptr->xlocks_root ) ,
+                     XPTR( lock_cxy , &lock_ptr->list ) );
+
+	    hal_restore_irq(mode);  
+	    return 0;
+    }
+}
+
+////////////////////////////////////////
+void remote_spinlock_lock( xptr_t lock )
+{
+    bool_t              isAtomic = false;
+	uint32_t            mode;
+    volatile uint32_t   taken;
+
+    // get cluster and local pointer on remote_spinlock
+    remote_spinlock_t * lock_ptr = (remote_spinlock_t *)GET_PTR( lock );
+    cxy_t               lock_cxy = GET_CXY( lock );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // disable interrupts
+	hal_disable_irq( &mode );
+  
+    // loop until success 
+	while( isAtomic == false )
+	{
+		taken = hal_remote_lw( XPTR( lock_cxy , &lock_ptr->taken ) );
+
+        // deschedule if possible when lock already taken
+		if( taken != 0 )
+		{
+	        hal_restore_irq( mode );
+            if( thread_can_yield() ) sched_yield();
+	        hal_disable_irq( &mode );
+			continue;
+		}
+    
+        // try to take the lock if not already taken
+		isAtomic = hal_remote_atomic_cas( XPTR( lock_cxy , &lock_ptr->taken ) , 0 , 1 );
+	}
+
+    // register lock in thread
+	thread_ptr->remote_locks++;
+
+    hal_remote_swd( XPTR( lock_cxy , &lock_ptr->owner ) ,
+                    (uint64_t)XPTR( thread_cxy , thread_ptr) );
+
+    xlist_add_first( XPTR( thread_cxy , &thread_ptr->xlocks_root ) ,
+                     XPTR( lock_cxy , &lock_ptr->list ) );
+
+    // enable interrupts
+	hal_restore_irq( mode );
+}
+
+//////////////////////////////////////////
+void remote_spinlock_unlock( xptr_t lock )
+{
+    // get cluster and local pointer on remote_spinlock
+    remote_spinlock_t * lock_ptr = (remote_spinlock_t *)GET_PTR( lock );
+    cxy_t               lock_cxy = GET_CXY( lock );
+
+    // get pointer on local thread
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+	hal_remote_swd( XPTR( lock_cxy , &lock_ptr->owner ) , XPTR_NULL );
+
+	hal_remote_sw ( XPTR( lock_cxy , &lock_ptr->taken ) , 0 );
+
+	thread_ptr->remote_locks--;
+
+    xlist_unlink( XPTR( lock_cxy , &lock_ptr->list ) );
+}
+
Index: trunk/kernel/libk/remote_spinlock.h
===================================================================
--- trunk/kernel/libk/remote_spinlock.h	(revision 1)
+++ trunk/kernel/libk/remote_spinlock.h	(revision 1)
@@ -0,0 +1,80 @@
+/*
+ * remote_spinlock.h - kernel remote spinlock definition.
+ *
+ * Authors  Mohamed Karaoui (2016)
+ *          Alain Greiner   (2016)
+ * 
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _REMOTE_SPINLOCK_H_
+#define _REMOTE_SPINLOCK_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <xlist.h>
+
+/***************************************************************************************
+ * This structure defines a remote spinlock, that can be used to protect
+ * exclusive access to a trans-cluster shared resource. It can be taken by any 
+ * thread running in any cluster. All access functions use remote pointers,
+ * and the owner thread is registrated as a remote pointer.
+ **************************************************************************************/
+
+typedef struct remote_spinlock_s
+{
+    volatile uint32_t     taken;       /*! free if 0 / taken if non zero             */
+    xptr_t                owner;       /*! extended pointer on the owner thread      */
+    xlist_entry_t         list;        /*! list of all remote_lock taken by owner    */
+} 
+remote_spinlock_t;
+
+/***************************************************************************************
+ * This function initializes a remote spinlock.
+ ***************************************************************************************
+ * @ lock    : extended pointer on the remote spinlock
+ **************************************************************************************/
+void remote_spinlock_init( xptr_t   lock );
+
+/***************************************************************************************
+ * This blocking function locks a remote spinlock.
+ * If the lock is already taken, the calling thread deschedule, and retry
+ * when it is rescheduled.
+ * It increments the calling thread locks count when the lock has been taken.
+ ***************************************************************************************
+ * @ lock    : extended pointer on the remote spinlock
+ **************************************************************************************/
+void remote_spinlock_lock( xptr_t lock );
+
+/***************************************************************************************
+ * This non blocking function try once to lock a remote spinlock.
+ * It increments the calling thread locks count in case of success.
+ ***************************************************************************************
+ * @ lock    : extended pointer on the remote spinlock
+ * @ returns O if success / returns non zero if lock already taken.
+ **************************************************************************************/
+uint32_t remote_spinlock_trylock( xptr_t lock );
+
+/***************************************************************************************
+ * This function releases a remote spinlock.
+ ***************************************************************************************
+ * @ lock    : extended pointer on the remote spinlock
+ **************************************************************************************/
+void remote_spinlock_unlock( xptr_t lock );
+
+#endif
Index: trunk/kernel/libk/rwlock.c
===================================================================
--- trunk/kernel/libk/rwlock.c	(revision 690)
+++ trunk/kernel/libk/rwlock.c	(revision 1)
@@ -1,6 +1,6 @@
 /*
- * rwlock.c - kernel local read/write lock implementation.
+ * rwlock.c - kernel read/write lock synchronization.
  * 
- * Author  Alain Greiner     (2016,2017,2018,2019)
+ * Author  Alain Greiner     (2016}
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -22,6 +22,6 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_atomic.h>
 #include <hal_special.h>
@@ -31,311 +31,117 @@
 #include <rwlock.h>
 
-//////////////////////////////////////////////////////////////////////////////
-//                Extern global variables
-//////////////////////////////////////////////////////////////////////////////
-
-extern char * lock_type_str[];          // allocated in kernel_init.c
-
-
-//////////////////////////////////
-void rwlock_init( rwlock_t * lock,
-                  uint32_t   type )
+///////////////////////////////////////
+void rwlock_init( rwlock_t * lock )
 {  
-	lock->taken   = 0;
+	lock->ticket  = 0;
+    lock->current = 0;
     lock->count   = 0;
-
-    list_root_init( &lock->rd_root );
-    list_root_init( &lock->wr_root );
-
-    busylock_init( &lock->lock , type );
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this = CURRENT_THREAD;
-bool_t     cond = (lock_type == DEBUG_RWLOCK_TYPE) &&
-                  (((local_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock == (rwlock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-if( cond ) printk("\n[%s] thread[%x,%x] initialise lock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid,
-lock_type_str[type], local_cxy, lock );
-#endif
-
+	lock->owner   = NULL;
 }
 
-/////////////////////////////////////////
-void rwlock_rd_acquire( rwlock_t * lock )
+//////////////////////////////////////
+void rwlock_rd_lock( rwlock_t * lock )
 {
-    thread_t * this = CURRENT_THREAD;
+	uint32_t            mode;
+	uint32_t            ticket;
+	thread_t          * this = CURRENT_THREAD;
 
-    // check calling thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
+    // disable IRQs
+	hal_disable_irq( &mode );
 
-    // get busylock
-    busylock_acquire( &lock->lock );
+    // get next free ticket
+    ticket = hal_atomic_add( &lock->ticket , 1 );
+  
+    // poll the current ticket value
+	while( lock->current != ticket )
+    {
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
+    }
 
-#if DEBUG_RWLOCK_TYPE
-uint32_t   lock_type = lock->lock.type;
-bool_t     cond = (lock_type == DEBUG_RWLOCK_TYPE) &&
-                  (((local_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock == (rwlock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-#endif
-
-    // block and deschedule if lock already taken
-    while( lock->taken )
-    {
-
-#if DEBUG_RWLOCK_TYPE
-if( cond ) 
-printk("\n[%s] thread[%x,%x] READ BLOCK on rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
-        // register reader thread in waiting queue
-        list_add_last( &lock->rd_root , &this->wait_list );
-
-        // block reader thread
-        thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_LOCK );
-        
-        // release busylock
-        busylock_release( &lock->lock );
-
-        // deschedule
-        sched_yield("reader wait rwlock");
-        
-        // get busylock
-        busylock_acquire( &lock->lock );
-    }
+    ////////// From here we have the lock  ////////////
 
     // increment number of readers
     lock->count++;
+    this->local_locks++;
 
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] READ ACQUIRE rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
+    // consistency
+    hal_wbflush();
 
-    // release busylock 
-    busylock_release( &lock->lock );
+    // release the lock to allow several simultaneous readers
+    lock->current++;
 
-}  // end rwlock_rd_acquire() 
+    // enable IRQs
+	hal_restore_irq( mode );
 
-/////////////////////////////////////////
-void rwlock_wr_acquire( rwlock_t * lock )
+}  // end  rwlock_rd_lock()
+
+////////////////////////////////////////
+void rwlock_rd_unlock( rwlock_t * lock )
 {
-    thread_t * this = CURRENT_THREAD;
+    uint32_t   mode;
+	thread_t * this = CURRENT_THREAD;
 
-    // check calling thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
+    // disable IRQs
+	hal_disable_irq( &mode );
+  
+    // decrement number of readers
+    hal_atomic_dec( &lock->count );
+    this->local_locks--;
 
-    // get busylock
-    busylock_acquire( &lock->lock );
+    // enable IRQs
+	hal_restore_irq( mode );
+}
 
-#if DEBUG_RWLOCK_TYPE
-uint32_t   lock_type = lock->lock.type;
-bool_t     cond = (lock_type == DEBUG_RWLOCK_TYPE) &&
-                  (((local_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock == (rwlock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-#endif
+//////////////////////////////////////
+void rwlock_wr_lock( rwlock_t * lock )
+{
+	uint32_t           mode;
+    uint32_t           ticket;
+	thread_t         * this = CURRENT_THREAD;
 
-    // block and deschedule if lock already taken or existing read access
-    while( lock->taken || lock->count )
+    // disable IRQs
+	hal_disable_irq( &mode );
+  
+    // get next free ticket
+    ticket = hal_atomic_add( &lock->ticket , 1 );
+  
+    // poll the current ticket value
+	while( lock->current != ticket )
     {
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
+    } 
 
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE BLOCK on rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
-        // register writer in waiting queue
-        list_add_last( &lock->wr_root , &this->wait_list );
+    ////////// From here we have the lock  ////////////
 
-        // block writer thread
-        thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_LOCK );
-        
-        // release busylock
-        busylock_release( &lock->lock );
-
-        // deschedule
-        sched_yield("writer wait rwlock");
-        
-        // get busylock
-        busylock_acquire( &lock->lock );
+    // wait completion of existing read access
+    while( lock->count != 0 )
+    {
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
     }
 
-    // take the rwlock
-    lock->taken = 1;
+    lock->owner = this;
+    this->local_locks++;
 
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE ACQUIRE rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
+    // enable IRQs
+	hal_restore_irq( mode );
 
-    // release busylock 
-    busylock_release( &lock->lock );
+}  // end rwlock_wr_lock()
 
-}  // end rwlock_wr_acquire()
+////////////////////////////////////////////
+void rwlock_wr_unlock( rwlock_t * lock )
+{
+    uint32_t   mode;
+	thread_t * this = CURRENT_THREAD;
 
-/////////////////////////////////////////
-void rwlock_rd_release( rwlock_t * lock )
-{
-    // synchronize memory before lock release
-    hal_fence();
+    // disable IRQs
+	hal_disable_irq( &mode );
+  
+    // release lock
+    lock->current++;
+    lock->owner = NULL;
+    this->local_locks--;
+    
+    // enable IRQs
+	hal_restore_irq( mode );
+}
 
-    // get busylock
-    busylock_acquire( &lock->lock );
-
-    // decrement number of readers
-    lock->count--;
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this = CURRENT_THREAD;
-uint32_t   lock_type = lock->lock.type;
-bool_t     cond = (lock_type == DEBUG_RWLOCK_TYPE) &&
-                  (((local_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock == (rwlock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-#endif
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] READ RELEASE rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
-
-    // release first writer in waiting queue if no current readers
-    // and writers waiting queue non empty
-    if( (lock->count == 0) && (list_is_empty( &lock->wr_root ) == false) )
-    {
-        // get first writer thread
-        thread_t * thread = LIST_FIRST( &lock->wr_root , thread_t , wait_list );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, thread->process->pid, thread->trdid,
-lock_type_str[lock_type], local_cxy, lock );
-#endif
-
-        // remove this waiting thread from waiting list
-        list_unlink( &thread->wait_list );
-
-        // unblock this waiting thread
-        thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_LOCK );
-    }
-    // release all readers in waiting queue if writers waiting queue empty
-    // and readers waiting queue non empty
-    else if( list_is_empty( &lock->wr_root ) && (list_is_empty( &lock->rd_root ) == false) )
-    {
-        while( list_is_empty( &lock->rd_root ) == false )
-        {
-            // get first reader thread 
-            thread_t * thread = LIST_FIRST( &lock->wr_root , thread_t , wait_list );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, thread->process->pid, thread->trdid,
-lock_type_str[lock_type], local_cxy, lock );
-#endif
-   
-            // remove this waiting thread from waiting list
-            list_unlink( &thread->wait_list );
-
-            // unblock this waiting thread
-            thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_LOCK );
-        }
-    }
-
-    // release busylock 
-    busylock_release( &lock->lock );
-
-}  // end rwlock_rd_release()
-
-/////////////////////////////////////////
-void rwlock_wr_release( rwlock_t * lock )
-{
-    // synchronize memory before lock release
-    hal_fence();
-
-    // get busylock
-    busylock_acquire( &lock->lock );
-
-    // release the rwlock
-    lock->taken = 0;
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this = CURRENT_THREAD;
-uint32_t   lock_type = lock->lock.type;
-bool_t     cond = (lock_type == DEBUG_RWLOCK_TYPE) &&
-                  (((local_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock == (rwlock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-#endif
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE RELEASE rwlock %s [%x,%x] / taken %d / count %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], local_cxy, lock, lock->taken, lock->count );
-#endif
-
-    // release first waiting writer thread if writers waiting queue non empty
-    if( list_is_empty( &lock->wr_root ) == false )
-    {
-        // get first writer thread
-        thread_t * thread = LIST_FIRST( &lock->wr_root , thread_t , wait_list );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, thread->process->pid, thread->trdid,
-lock_type_str[lock_type], local_cxy, lock );
-#endif
-        // remove this waiting thread from waiting list
-        list_unlink( &thread->wait_list );
-
-        // unblock this waiting thread
-        thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_LOCK );
-    }
-
-    // check readers waiting queue and release all if writers waiting queue empty
-    else 
-    {
-        while( list_is_empty( &lock->rd_root ) == false )
-        {
-            // get first reader thread 
-            thread_t * thread = LIST_FIRST( &lock->rd_root , thread_t , wait_list );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid, thread->process->pid, thread->trdid,
-lock_type_str[lock_type], local_cxy, lock );
-#endif
-            // remove this waiting thread from waiting list
-            list_unlink( &thread->wait_list );
-
-            // unblock this waiting thread
-            thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_LOCK );
-        }
-    }
-
-    // release busylock 
-    busylock_release( &lock->lock );
-
-}  // end rwlock_wr_release()
-
-
